=== input/CMakeLists.txt ===
# Copy input files into the shared directory for testing.
install(DIRECTORY
  "${CMAKE_CURRENT_SOURCE_DIR}/Autogenerated"
  "${CMAKE_CURRENT_SOURCE_DIR}/Baobab"
  "${CMAKE_CURRENT_SOURCE_DIR}/Chinese"
  "${CMAKE_CURRENT_SOURCE_DIR}/CEA9601"
  "${CMAKE_CURRENT_SOURCE_DIR}/ne574"
  "${CMAKE_CURRENT_SOURCE_DIR}/SmallTree"
  "${CMAKE_CURRENT_SOURCE_DIR}/BSCU"
  "${CMAKE_CURRENT_SOURCE_DIR}/Theatre"
  "${CMAKE_CURRENT_SOURCE_DIR}/TwoTrain"
  "${CMAKE_CURRENT_SOURCE_DIR}/ThreeMotor"
  "${CMAKE_CURRENT_SOURCE_DIR}/Lift"
  "${CMAKE_CURRENT_SOURCE_DIR}/HIPPS"
  "${CMAKE_CURRENT_SOURCE_DIR}/EventTrees"
  DESTINATION share/scram/input
  COMPONENT examples
  )
