=== debian/changelog ===
scram (0.15.0-1) unstable; urgency=medium

  * New upstream 0.15.0
  * Remove the '.desktop' patch (pushed to upstream)
  * Drop 'dh-exec' (upstream provides renamed 'scram' completion)
  * Remove 'libscramgui.so' installation (removed by upstream)
  * Update man pages

 -- Olzhas Rakhimov <ol.rakhimov@gmail.com>  Mon, 14 Aug 2017 22:08:24 -0700
