=== debian/control ===
Source: scram
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Olzhas Rakhimov <ol.rakhimov@gmail.com>
Build-Depends: debhelper (>= 10),
               cmake (>= 2.8.12),
               libxml++2.6-dev (>= 2.38.1),
               libboost-all-dev (>= 1.58.0),
               libgoogle-perftools-dev,
               qtbase5-dev (>= 5.2.1),
               qtbase5-dev-tools,
               libqt5svg5-dev,
               libqt5opengl5-dev
Standards-Version: 4.0.1
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/scram.git
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/scram.git
Homepage: https://scram-pra.org

Package: scram
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Probabilistic Risk Analysis Tool
 A command line probabilistic risk analysis tool
 capable of performing event tree analysis,
 static fault tree analysis,
 analysis with common cause failure models,
 probability calculations with importance analysis,
 and uncertainty analysis with Monte Carlo simulations.

Package: scram-gui
Architecture: any
Depends: scram, ${shlibs:Depends}, ${misc:Depends}
Description: SCRAM GUI front-end
 The complementary SCRAM GUI front-end
 for visualization and manipulation
 of risk anlysis models and reports.
