## scram 0.16.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 project(SCRAM)
 set(SCRAM_VERSION_MAJOR 0)  # Indicate major API change after 1.0.0
-set(SCRAM_VERSION_MINOR 15)  # New features and improvements.
+set(SCRAM_VERSION_MINOR 16)  # New features and improvements.
 set(SCRAM_VERSION_MICRO 0)  # Bug fixes.
 
 ####################### Begin Options ###################
@@ -63,12 +63,15 @@
 endfunction()
 
 set(CMAKE_CXX_FLAGS_DEBUG
-  "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Werror -Wno-sign-compare -Wnon-virtual-dtor -Wno-missing-field-initializers")
+  "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra -Werror -Wno-sign-compare -Wnon-virtual-dtor -Wno-missing-field-initializers -Wold-style-cast")
 
 if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
   CHECK_COMPILER_VERSION("4.9")  # TODO: Wpedantic with gcc 4.9 errors with default arg lambdas.
+  set(CMAKE_CXX_FLAGS_DEBUG
+    "${CMAKE_CXX_FLAGS_DEBUG} -Wredundant-decls -Wcast-align -Wlogical-op -Wvla -Wuseless-cast -Wunreachable-code")
+
   if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5)
-    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wshadow -Wpedantic")
+    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wshadow -Wpedantic -Wmissing-declarations")
   endif()
 
 elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
@@ -80,11 +83,11 @@
   CHECK_COMPILER_VERSION("6.1")
 
 elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
-  CHECK_COMPILER_VERSION("17.0.1")
+  CHECK_COMPILER_VERSION("17.0.2")
   # TODO: CMAKE_CXX_STANDARD has no effect on icc.
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
-  # TODO: Bug in Intel compiler with multi-initialization with auto and final-is-not-override.
-  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=3373,1125")
+  # TODO: Warning with overload of private override.
+  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -diag-disable=1125")
 endif()
 
 if(WIN32)
@@ -167,17 +170,21 @@
 endif()
 message(STATUS "The memory allocator: ${MALLOC}")
 
-# Find LibXML++ and dependencies.
-set(LIBXML++_MIN_VERSION "2.38.1")  # TODO: Fix the minimum version check.
-find_package(LibXML++ "${LIBXML++_MIN_VERSION}" REQUIRED)
-set(LIBS ${LIBS} ${LibXML++_LIBRARIES})
+# Find LibXML2 and dependencies.
+find_package(LibXml2 REQUIRED)
+set(LIBS ${LIBS} ${LIBXML2_LIBRARIES})
 
 message(STATUS ${LIBS})
 
 # Include the boost header files and the program_options library.
 # Please be sure to use Boost rather than BOOST.
 # Capitalization matters on some platforms.
-set(BOOST_MIN_VERSION "1.58.0")
+if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
+  set(BOOST_MIN_VERSION "1.58.0")
+  set(LIBS ${LIBS} ${CMAKE_DL_LIBS})
+else()
+  set(BOOST_MIN_VERSION "1.61.0")
+endif()
 set(Boost_USE_STATIC_LIBS ${WITH_STATIC_LIBS})
 set(Boost_USE_STATIC_RUNTIME ${WITH_STATIC_LIBS})
 
@@ -218,9 +225,6 @@
 
 # Include all the discovered system directories.
 include_directories(SYSTEM "${Boost_INCLUDE_DIR}")
-include_directories(SYSTEM "${LibXML++_INCLUDE_DIR}")
-include_directories(SYSTEM "${LibXML++Config_INCLUDE_DIR}")
-include_directories(SYSTEM ${Glibmm_INCLUDE_DIRS})
 include_directories(SYSTEM "${LIBXML2_INCLUDE_DIR}")
 
 include_directories("${PROJECT_SOURCE_DIR}")  # Include the core headers via "src".
