=== debian/changelog ===
scram (0.16.0-1) unstable; urgency=medium

  [ Olzhas Rakhimov ]
  * New upstream 0.16.0
  * Drop libxml++
  * Add libxml2, qttools5-dev, qttools5-dev-tools to dependencies
  * Add GUI translations installations
  * Bump the standards version to 4.1.1
  * Update manpages

  [ Sébastien Villemot ]
  * Fix typo in long description (Closes: #871662)

 -- Olzhas Rakhimov <ol.rakhimov@gmail.com>  Sat, 18 Nov 2017 17:44:50 -0800
