=== debian/control ===
--- 
+++ 
@@ -5,14 +5,16 @@
 Uploaders: Olzhas Rakhimov <ol.rakhimov@gmail.com>
 Build-Depends: debhelper (>= 10),
                cmake (>= 2.8.12),
-               libxml++2.6-dev (>= 2.38.1),
+               libxml2-dev (>= 2.9.1),
                libboost-all-dev (>= 1.58.0),
                libgoogle-perftools-dev,
                qtbase5-dev (>= 5.2.1),
                qtbase5-dev-tools,
+               qttools5-dev,
+               qttools5-dev-tools,
                libqt5svg5-dev,
                libqt5opengl5-dev
-Standards-Version: 4.0.1
+Standards-Version: 4.1.1
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/scram.git
 Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/scram.git
 Homepage: https://scram-pra.org
@@ -34,4 +36,4 @@
 Description: SCRAM GUI front-end
  The complementary SCRAM GUI front-end
  for visualization and manipulation
- of risk anlysis models and reports.
+ of risk analysis models and reports.
