=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_PREPEND = -Wl,-z,defs -Wl,--as-needed
export QT_SELECT=qt5

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DCMAKE_BUILD_TYPE=Release \
		-DBUILD_TESTS=OFF

override_dh_install:
	dh_install --list-missing

%:
	dh $@ --buildsystem=cmake
